unit itbmain;
{ Icon to Gif Converter
Copyright Alec Ford, Bobcat Utilities 2001
It's a simple program, use as an example for simple code
Distribute freely but with acknowledgement}
interface

uses
  ShellAPI, WinTypes, 

  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ExtDlgs;

type
  TForm1 = class(TForm)
    Image2: TImage;
    Open: TButton;
    Save: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    OpenDialog1: TOpenDialog;
    procedure OpenClick(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure get_icon(filename : string);
    
    protected
    procedure WMDROPFILES (var Msg: TWMDropFiles); message WM_DROPFILES;
  private

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
var fn :string;

procedure TForm1.get_icon(filename : string);
VAr ic : Ticon;
begin
   ic := Ticon.create;
    fn := filename;
 //   if uppercase(extractfileExt(fn)) = '.ICO' then ic.loadfromfile(OpenPictureDialog1.filename );
 	Ic.Handle := ExtractIcon(hInstance, pchar(fn), 0);

    image2.canvas.fillrect(rect(0,0,32,32));
    image2.canvas.draw(0,0,ic);
    ic.free;
    image2.picture.bitmap.height := 32;
    image2.picture.bitmap.width := 32;

end;                                               

procedure TForm1.OpenClick(Sender: TObject);
VAr ic : Ticon;
begin
//    OpenPictureDialog1.filterindex := 5;
//   if OpenPictureDialog1.execute then
   if OpenDialog1.execute then
    begin
    get_icon(OpenDialog1.filename)
    end;

end;

procedure TForm1.SaveClick(Sender: TObject);
begin
SavePictureDialog1.filterindex := 4;
//SavePictureDialog1.initialdir := extractfilepath(fn);
SavePictureDialog1.filename := changefileext(fn,'.bmp');
if SavePictureDialog1.execute then
	image2.picture.bitmap.savetofile(SavePictureDialog1.filename);
end;

procedure TForm1.FormCreate(Sender: TObject);
VAr ic : Ticon;
begin
DragAcceptFiles(Handle, True);
if paramstr(1) <> '' then
   begin
{ifdef wincrt then }
//writeln(paramstr(1));
{endif}
   get_icon(paramstr(1))
   end;

end;

procedure TForm1.WMDROPFILES(var Msg: TWMDropFiles);
var
  i, amount: Integer;
  FileName: array[0..MAX_PATH] of Char;
begin
  inherited;
 
  try                                //  vvvv  indicates get number in list
    Amount := DragQueryFile(Msg.Drop, $FFFFFFFF, FileName, MAX_PATH);
    for i := 0 to 0 do // >> to process a list>>(Amount - 1) do
    begin
      DragQueryFile(Msg.Drop, i, FileName, MAX_PATH);
    //do something with file
    get_icon(FileName)
    end;
  finally
    DragFinish(Msg.Drop);
end;
end;


end.
